"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const co_1 = require("co");
const npminstall = require("npminstall");
/// <reference path="../types/ambient.d.ts"/>
class PackageManager {
    constructor(defaultOptions) {
        this.npmOptions = defaultOptions;
    }
    install(packages) {
        return __awaiter(this, void 0, void 0, function* () {
            const options = Object.assign({}, this.npmOptions, { pkgs: packages });
            return yield co_1.default(function* () {
                return yield npminstall(options);
            });
        });
    }
    installPackages(packageNames) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.install(packageNames.map(name => ({ name, version: '*' })));
        });
    }
    installPackage(packageName) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.install([{ name: packageName, version: '*' }]);
        });
    }
}
exports.PackageManager = PackageManager;
