/// <reference types="node" />
import { Task as TaskType, History } from '../types';
import { PackageManager } from './PackageManager';
export declare class Task implements TaskType.Registered {
    private initialized;
    private taskRoot;
    taskName: string;
    status: TaskType.Status;
    timer: NodeJS.Timer;
    history: Array<History.Record>;
    schedule: string;
    timeout?: string | number;
    version: string;
    singleton: boolean;
    data: any;
    packageManager: PackageManager;
    constructor(taskName: any, taskRoot: any, packageManager: any);
    restartTimer(): void;
    stopTimer(): void;
    init(): Promise<void>;
    reload(): Promise<void>;
    run(): Promise<void>;
    updateSelf(): Promise<any>;
}
