"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.runner = (packageName) => `
module.exports = (function (data) {
  const co = require('co');
  return co(function* () {
    const task = require('${packageName}');
    let shouldRun = true;
    if (task.shouldRun) {
      const shouldRunResult = task.shouldRun(data);
      if (shouldRunResult && shouldRunResult.then) {
        shouldRun = yield shouldRunResult;
      } else {
        shouldRun = shouldRunResult;
      }
    }
    if (shouldRun) {
      const runResult = task.run(data);
      let dataResult = runResult;
      if (runResult && runResult.then) {
        dataResult = yield runResult;
      }
      return { type: 'finished', data: dataResult };
    } else {
      return { type: 'canceled' };
    }
  });
})(global);
`;
exports.configParser = (packageName) => `
module.exports = (function (data) {
  return new Promise((resolve, reject) => {
    const task = require('${packageName}');
    const {version} = require('${packageName}/package.json');
    console.log(task);
    if (task && task.then) {
      task.then(t => resolve({task:t, version}));
    } else {
      resolve({ task, version });
    }
  });
})(global);
`;
