declare module 'npminstall' {
  interface pkg {
    name: string;
    version: string;
  }

  export interface Options {
    // install root dir
    root: string;
    // optional packages need to install, default is package.json's dependencies and devDependencies
    pkgs?: Array<pkg>;
    // install to specific directory, default to root
    targetDir?: string;
    // link bin to specific directory (for global install)
    binDir?: string;
    // registry, default is https://registry.npmjs.org
    registry?: string;
    debug?: boolean;
    storeDir?: string;
    ignoreScripts?: boolean; // ignore pre/post install scripts, default is `false`
    forbiddenLicenses?: Array<string>;
  }

  const content: (options: Options) => Promise<void>;
  export default content;
}

declare module 'co' {
  const content: (func:Iterable<any>) => Promise<any>;
  export default content;
}
